
#include <strlen.h>
#include <stdint.h>

/* convert integer i into string of hex digits at string s. */
void itox(uintptr_t i, char *s)
{
    unsigned char n;
    
    /* 4-byte integers print 8 chars, 8-byte integers print 16 bytes */
    s += 2*sizeof(void*);
    *s = '\0';
 
    for (n = 2*sizeof(void*); n != 0; --n) {
        *--s = "0123456789ABCDEF"[i & 0x0F];
        i >>= 4;
    }
}
