/*
 * Copyright (c) 2014 - Zephyr Software LLC
 *
 * This file may be used and modified for non-commercial purposes as long as
 * all copyright, permission, and nonwarranty notices are preserved.
 * Redistribution is prohibited without prior written consent from Zephyr
 * Software.
 *
 * Please contact the authors for restrictions applying to commercial use.
 *
 * THIS SOURCE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Author: Zephyr Software
 * e-mail: jwd@zephyr-software.com
 * URL   : http://www.zephyr-software.com/
 *
 */

#ifndef stdint_h
#define stdint_h

#define NULL 0

#ifdef LINUX64
	typedef signed long long int ssize_t;
	typedef unsigned long long int size_t;
	typedef unsigned long long int uintptr_t;
	typedef unsigned long long int uint64_t;
	typedef unsigned short int uint16_t;
	typedef unsigned int uint32_t;
	typedef unsigned char uint8_t;
#else
	typedef signed long int ssize_t;
	typedef unsigned long int size_t;
	typedef unsigned long int uintptr_t;
#endif

#endif
